# -*- python -*-
# $RCSfile: mainmenuGUI.py,v $
# $Revision: 1.33 $
# $Author: langer $
# $Date: 2004/12/21 18:42:30 $


# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# This file adds GUI code to the menu items defined in common.IO.mainmenu

from common.IO import gfxmanager
from common.IO.GUI.fileselector import fileSelector, get_file_mode
from common.guitop import top
from common import debug
from common.IO import mainmenu
from common.IO import oofmenu
from common.IO import parameter
from common.IO.GUI import activityViewer
from common.IO.GUI import layereditorGUI

##########################

def load(menuitem):
    file = fileSelector(ident='FileMenu', title='Load Python Script')
    if not file is None:
        menuitem(filename=file)
mainmenu.OOF.File.Load.Script.add_gui_callback(load)

def save_log(menuitem):
    file = fileSelector(ident='FileMenu', title='Save Python Log')
    if not file is None:
        menuitem(filename=file)
mainmenu.OOF.File.Save.Python_Log.add_gui_callback(save_log)

def load_data(menuitem):
    file = fileSelector(ident='FileMenu_data', title='Load data file')
    if not file is None:
        menuitem(filename=file)
mainmenu.OOF.File.Load.Data.add_gui_callback(load_data)

############################
        
from common.IO.GUI import quit
mainmenu.OOF.File.Quit.add_gui_callback(quit.quit)

############################

def open_activityviewer(menuitem):
    activityViewer.openActivityViewer()
    menuitem()                          # just logs this command
mainmenu.OOF.Windows.Activity_Viewer.add_gui_callback(open_activityviewer)

############################

def toggleTips(menuitem, value):
    if value:
        top().tooltips.enable()
    else:
        top().tooltips.disable()

mainmenu.OOF.Help.addItem(
    oofmenu.CheckOOFMenuItem('Show_Tooltips', 1,
                             callback=toggleTips,
                             gui_only=1,
                             ordering=-9,
                             help='Turn annoying pop-up hints off.'))
