// -*- C++ -*-
// $RCSfile: mvmult.h,v $
// $Revision: 1.5 $
// $Author: reida $
// $Date: 2003/04/02 14:52:26 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#ifndef MVMULT_H
#define MVMULT_H

#include "engine/matvec.h"

VECTOR_D operator*(const MATRIX_D &a, const VECTOR_D &v); // A * v
VECTOR_D trans_mult(const MATRIX_D &a, const VECTOR_D &v); // A^T * v

MATRIX_D operator*(const MATRIX_D &a, const MATRIX_D &b); // A * B
MATRIX_D trans_mult(const MATRIX_D &a, const MATRIX_D &b); // A^T * B
MATRIX_D mult_trans(const MATRIX_D &a, const MATRIX_D &b); // A * B^T

MATRIX_D transform(const MATRIX_D &m, const MATRIX_D &a); // A * M * A^T


#endif // MVMULT_H
