# -*- python -*-
# $RCSfile: sparselink_.py,v $
# $Revision: 1.2 $
# $Author: reida $
# $Date: 2003/04/02 14:52:37 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

def _SparseLinkMat___setitem__(self, idx, val):
    self.set(idx[0], idx[1], val)

SparseLinkMat.__setitem__ = _SparseLinkMat___setitem__

def _SparseLinkMat___getitem__(self, idx):
    return self.get(idx[0], idx[1])

SparseLinkMat.__getitem__ = _SparseLinkMat___getitem__


def _SparseLinkMat_iterator(self):
    return SparseLinkMatIterator(self)

SparseLinkMatPtr.iterator = _SparseLinkMat_iterator

class SparseLinkMatIterator:
    def __init__(self, slm):
        self.slm = slm
        self.iter = slm.begin()
        self.end = slm.end();
    def __getitem__(self, idx):
        if(not self.iter.lessthan(self.end)):
            raise IndexError
        ans = (self.iter.row(), self.iter.col(), self.iter.value())
        self.iter.next()
        return ans
        
def _structure(self):
    # make an array of dashes
    structure = [[ '-' for i in range(self.ncols()) ] + ['\n']
                 for j in range(self.nrows()) ]
    # replace dashes by 'X's for each non-zero entry in the matrix
    for ij in self.iterator():
        structure[ij[0]][ij[1]] = 'X'
    # join each line into a string, without spaces between characters,
    # and prepend the line number
    structure = ["%3d "%i + string.join(structure[i], '')
                 for i in range(self.nrows())]

    header = "    " + ('0123456789'*(self.ncols()/10 + 1))[:self.ncols()] + '\n'
    return header + string.join(structure, '')

SparseLinkMatPtr.structure = _structure
